=== debian/changelog ===
openclonk (5.3.2-1) unstable; urgency=low

  * New upstream release.
    - Fixes FTBFS on some architectures (narrowing conversion to int8_t),
      but not all.
  * Drop fix-format-string-use.patch: applied upstream.
  * Add a manual page for openclonk.

 -- Philipp Kern <pkern@debian.org>  Mon, 19 Nov 2012 01:23:10 +0100

openclonk (5.3.1-1) unstable; urgency=low

  * Initial Debian release. (Closes: #531324)

 -- Philipp Kern <pkern@debian.org>  Sun, 21 Oct 2012 23:05:43 +0200

openclonk (5.1.2.4-0ubuntu1-ppa5) maverick; urgency=low

  * New Release

 -- Sebastian Rühl <sebastian.ruehl@mni.fh-giessen.de>  Sun, 31 Dec 2010 15:38:26 +0100

openclonk (5.1.1.0-0ubuntu1-ppa4) maverick; urgency=low

  * Mercurial as Build Dependency
  * Switch to cmake as build system
  * Fixed spacing issues in $(CURDIR)

 -- Sebastian Rühl <sebastian.ruehl@mni.fh-giessen.de>  Sun, 31 Dec 2010 15:38:26 +0100

openclonk (5.1.1.0-0ubuntu1-ppa3) maverick; urgency=low

  * Fixed Icons

 -- Sebastian Rühl <sebastian.ruehl@mni.fh-giessen.de>  Sun, 27 Dec 2010 15:23:05 +0200

openclonk (5.1.1.0-0ubuntu1-ppa2) maverick; urgency=low

  * Added Icons

 -- Sebastian Rühl <sebastian.ruehl@mni.fh-giessen.de>  Sun, 27 Dec 2010 12:23:05 +0200

openclonk (5.1.1.0-0ubuntu1-ppa1) maverick; urgency=low

  * Initial release

 -- Sebastian Rühl <sebastian.ruehl@mni.fh-giessen.de>  Sat, 25 Dec 2010 23:23:05 +0200
