## openclonk 5.3.3

=== debian/changelog ===
openclonk (5.3.3-3) unstable; urgency=high

  * Add a patch to pre-compute Z values before face ordering. (Closes: #693750)

 -- Philipp Kern <pkern@debian.org>  Thu, 26 Dec 2013 16:34:01 +0100

openclonk (5.3.3-2) unstable; urgency=low

  * Include a patch by Guillem Jover to fix an XRandR-related crash
    on startup. (Closes: #704632)

 -- Philipp Kern <pkern@debian.org>  Sun, 15 Sep 2013 12:08:35 +0200

openclonk (5.3.3-1) unstable; urgency=low

  * New upstream bugfix release.

 -- Philipp Kern <pkern@debian.org>  Fri, 15 Mar 2013 17:45:54 +0100
