=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake -Bbuild

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_AUTOMATIC_UPDATE=0

override_dh_auto_install:
	dh_auto_install
	mv debian/tmp/usr/share/applications/clonk.desktop \
		debian/tmp/usr/share/applications/openclonk.desktop
	sed -i -e 's/=clonk/=openclonk/g' debian/tmp/usr/share/applications/openclonk.desktop
	mv debian/tmp/usr/games/clonk debian/tmp/usr/games/openclonk

override_dh_strip:
	dh_strip --dbg-package=openclonk-dbg

override_dh_builddeb:
	dh_builddeb -- -Zxz
