## openclonk 5.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,27 +1,15 @@
 # OpenClonk, http://www.openclonk.org
 #
-# Copyright (c) 2009-2011  Günther Brammer
-# Copyright (c) 2009-2012  Nicolas Hake
-# Copyright (c) 2009  David Dormagen
-# Copyright (c) 2009-2012  Armin Burgmeier
-# Copyright (c) 2009-2010  Sven Eberhardt
-# Copyright (c) 2009  Tobias Zwick
-# Copyright (c) 2009  Richard Gerum
-# Copyright (c) 2010-2011  Julius Michaelis
-# Copyright (c) 2010-2011  Peter Wortmann
-# Copyright (c) 2010-2011  Martin Plicht
-# Copyright (c) 2010  Manuel Riecke
+# Copyright (c) 2009-2013, The OpenClonk Team and contributors
 #
-# Portions might be copyrighted by other authors who have contributed
-# to OpenClonk.
+# Distributed under the terms of the ISC license; see accompanying file
+# "COPYING" for details.
 #
-# Permission to use, copy, modify, and/or distribute this software for any
-# purpose with or without fee is hereby granted, provided that the above
-# copyright notice and this permission notice appear in all copies.
-# See isc_license.txt for full license and disclaimer.
+# "Clonk" is a registered trademark of Matthes Bender, used with permission.
+# See accompanying file "TRADEMARK" for details.
 #
-# "Clonk" is a registered trademark of Matthes Bender.
-# See clonk_trademark_license.txt for full license.
+# To redistribute this file separately, substitute the full license texts
+# for the above references.
 
 cmake_minimum_required (VERSION 2.6.0)
 project (openclonk CXX C)
@@ -29,7 +17,7 @@
 
 include(Version.txt)
 
-set(CMAKE_ADDITIONAL_DEPS_PATH deps CACHE PATH "Additional directory to search for libraries and headers")
+set(CMAKE_ADDITIONAL_DEPS_PATH "${CMAKE_CURRENT_BINARY_DIR}/deps" CACHE PATH "Additional directory to search for libraries and headers")
 list(APPEND CMAKE_PREFIX_PATH ${CMAKE_ADDITIONAL_DEPS_PATH})
 set(OC_CXX_FLAGS ${CMAKE_CXX_FLAGS})
 separate_arguments(OC_CXX_FLAGS)
@@ -40,54 +28,37 @@
 set(OC_EXE_LINKER_FLAGS_DEBUG ${CMAKE_EXE_LINKER_FLAGS_DEBUG})
 separate_arguments(OC_EXE_LINKER_FLAGS_DEBUG)
 
+function(unseparate_arguments _var _list)
+	foreach(_arg ${_list})
+		set(_string "${_string} ${_arg}")
+	endforeach()
+	set(${_var} "${_string}" PARENT_SCOPE)
+endfunction()
+
 ############################################################################
 # User selectable options
 ############################################################################
+include(CMakeDependentOption)
 option(PROJECT_FOLDERS "Put source files into subfolders in project file" ON)
-option(USE_GL "Enable OpenGL support" ON)
-SET(INITIAL_USE_SDL_MAINLOOP_VALUE OFF)
-SET(INITIAL_USE_OPEN_AL OFF)
-option(USE_SDL_MAINLOOP "Use SDL to create windows etc." ${INITIAL_USE_SDL_MAINLOOP_VALUE})
-if(WIN32 AND FALSE) # disable DX option while it doesn't work anyway
-	option(USE_DIRECTX "Enable DirectX support" ON)
-	if(EXISTS $ENV{DXSDK_DIR})
-		list(APPEND CMAKE_INCLUDE_PATH $ENV{DXSDK_DIR}/Include)
-		if(CMAKE_CL_64)
-			list(APPEND CMAKE_LIBRARY_PATH $ENV{DXSDK_DIR}/Lib/x64)
-		else()
-			list(APPEND CMAKE_LIBRARY_PATH $ENV{DXSDK_DIR}/Lib/x86)
-		endif()
-	else()
-
-	endif()
-else()
-	SET(USE_DIRECTX OFF)
-	SET(HAVE_FMOD OFF)
-endif()
-if(NOT USE_GL AND NOT USE_DIRECTX)
-	message(STATUS "No graphics display enabled; building dedicated server")
-	SET(USE_CONSOLE ON CACHE INTERNAL "Build dedicated server")
-endif()
-if(UNIX AND NOT USE_SDL_MAINLOOP AND NOT APPLE AND NOT USE_CONSOLE)
-	option(USE_X11 "Use X11 to create windows etc." ON)
-	option(USE_GTK "Use GTK for the developer mode" ON)
-	option(USE_GTK3 "Use GTK3 instead of GTK2" OFF)
-else()
-	SET(USE_X11 OFF)
-	SET(USE_GTK OFF)
-	SET(USE_GTK3 OFF)
-endif()
+option(USE_CONSOLE "Build dedicated server" OFF)
+CMAKE_DEPENDENT_OPTION(USE_SDL_MAINLOOP "Use SDL to create windows etc." OFF "NOT USE_CONSOLE" OFF)
+CMAKE_DEPENDENT_OPTION(USE_X11 "Use X11 to create windows etc." ON
+	"UNIX AND NOT APPLE AND NOT USE_SDL_MAINLOOP AND NOT USE_CONSOLE" OFF)
+CMAKE_DEPENDENT_OPTION(USE_GTK "Use GTK for the developer mode" ON "USE_X11" OFF)
+CMAKE_DEPENDENT_OPTION(USE_GTK3 "Use GTK3 instead of GTK2" OFF "USE_GTK" OFF)
+
+CMAKE_DEPENDENT_OPTION(USE_COCOA "Use Apple Cocoa for the developer mode and the windows." ON "APPLE" OFF)
+CMAKE_DEPENDENT_OPTION(USE_APPLE_CLANG "Use Apple Clang Compiler as C++ compiler." ON "APPLE" OFF)
 if(APPLE)
-	option(USE_COCOA "Use Apple Cocoa for the developer mode and the windows." ON)
-	option(USE_APPLE_CLANG "Use Apple Clang Compiler as C++ compiler." ON)
 	SET(INITIAL_USE_OPEN_AL ON)
 else()
-	option(USE_COCOA OFF)
+	SET(INITIAL_USE_OPEN_AL OFF)
 endif()
 option(USE_OPEN_AL "Use OpenAL to play sounds" ${INITIAL_USE_OPEN_AL})
-option(DEBUGREC "Debug records" OFF)
-option(OC_BUILD_MULTIPROCESSOR "Use all processor cores to build" OFF)
-option(WITH_AUTOMATIC_UPDATE "Build engine without automatic update support" OFF)
+option(WITH_AUTOMATIC_UPDATE "Automatic updates are downloaded from the project website." OFF)
+
+# Remove obsolete options
+unset(OC_BUILD_MULTIPROCESSOR CACHE)
 
 ############################################################################
 # Check for compiler quirks and features
@@ -111,20 +82,33 @@
 # out because it does not understand -std=gnu++0x
 set(SAFE_CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
 set(CMAKE_REQUIRED_FLAGS ${OC_REQUIRED_FLAGS})
+include(RequireCXXSourceCompiles)
+if (NOT USE_APPLE_CLANG)
+REQUIRE_CXX_SOURCE_COMPILES("#include <memory>\nint main() { std::unique_ptr<int> a; std::shared_ptr<int> b; }" HAVE_C11_SMART_PTRS)
+endif()
 CHECK_CXX_SOURCE_COMPILES("void f(struct D&&); int main() { return 0; }" HAVE_RVALUE_REF)
 CHECK_CXX_SOURCE_COMPILES("int main() { void *d = nullptr; }" HAVE_NULLPTR)
 CHECK_CXX_SOURCE_COMPILES("int main() { static_assert(true, \"\"); }" HAVE_STATIC_ASSERT)
 set(CMAKE_REQUIRED_FLAGS "${SAFE_CMAKE_REQUIRED_FLAGS}")
 
+# g++'s libstdc++ doesn't properly support <regex> until 4.8.1 (maybe later?).
+# They ship a header that declares functions, but they don't ship an
+# implementation for some things (like std::regex_iterator).
+# This needs to test *linking*, not compilation; cmake does both at the same
+# time, so the test below works.
+CHECK_CXX_SOURCE_COMPILES("#include <regex>\nint main() { std::cregex_iterator ri; }" HAVE_WORKING_REGEX)
+CMAKE_DEPENDENT_OPTION(USE_BOOST_REGEX "Use Boost.Regex even if the C++ runtime has a working implementation of <regex>" OFF "HAVE_WORKING_REGEX" ON)
+
+# We link Boost statically because that makes it easier for us to distribute
+# the resulting binary. Distributions have the ability to guarantee a certain
+# version of the library exists on the system though, so they may prefer
+# dynamic linking.
+option(USE_STATIC_BOOST "Link Boost libraries statically" ON)
+
 if(MSVC_VERSION GREATER 1499)
-	# Activate minimal rebuild
-	if(OC_BUILD_MULTIPROCESSOR)
 		list(APPEND OC_CXX_FLAGS /MP)
 		list(REMOVE_ITEM OC_CXX_FLAGS_DEBUG /Gm)
-	else()
-		list(REMOVE_ITEM OC_CXX_FLAGS /MP)
-		list(APPEND OC_CXX_FLAGS_DEBUG /Gm)
-	endif()
+
 	if (NOT CMAKE_CL_64)
 		# Activate edit-and-continue
 		list(REMOVE_ITEM OC_CXX_FLAGS_DEBUG /Zi)
@@ -160,23 +144,11 @@
 # 	configurations.
 set(OC_CLONK_SOURCES
 	src/C4Globals.cpp
-	src/c4group/C4ComponentHost.cpp
-	src/c4group/C4ComponentHost.h
 	src/c4group/C4Components.h
 	src/c4group/C4Extra.cpp
 	src/c4group/C4Extra.h
-	src/c4group/C4Group.cpp
-	src/c4group/C4Group.h
-	src/c4group/C4GroupSet.cpp
-	src/c4group/C4GroupSet.h
-	src/c4group/C4LangStringTable.cpp
-	src/c4group/C4LangStringTable.h
 	src/c4group/C4Language.cpp
 	src/c4group/C4Language.h
-	src/c4group/C4Update.cpp
-	src/c4group/C4Update.h
-	src/c4group/CStdFile.cpp
-	src/c4group/CStdFile.h
 	src/C4Include.h
 	src/C4Prototypes.h
 	src/C4Version.h
@@ -239,13 +211,10 @@
 	src/graphics/Bitmap256.cpp
 	src/graphics/Bitmap256.h
 	src/graphics/C4Draw.cpp
-	src/graphics/C4DrawD3D.cpp
-	src/graphics/C4DrawD3D.h
-	src/graphics/C4DrawD3DShader.cpp
-	src/graphics/C4DrawD3DShader.h
 	src/graphics/C4DrawGL.cpp
 	src/graphics/C4DrawGLCtx.cpp
 	src/graphics/C4DrawGL.h
+	src/graphics/C4DrawMeshGL.cpp
 	src/graphics/C4DrawT.cpp
 	src/graphics/C4DrawT.h
 	src/graphics/C4Draw.h
@@ -253,8 +222,8 @@
 	src/graphics/C4FacetEx.cpp
 	src/graphics/C4FacetEx.h
 	src/graphics/C4Facet.h
-	src/graphics/C4Fonts.cpp
-	src/graphics/C4Fonts.h
+	src/graphics/C4FontLoader.cpp
+	src/graphics/C4FontLoader.h
 	src/graphics/C4GraphicsResource.cpp
 	src/graphics/C4GraphicsResource.h
 	src/graphics/C4Surface.cpp
@@ -339,6 +308,9 @@
 	src/landscape/C4MapCreatorS2.cpp
 	src/landscape/C4MapCreatorS2.h
 	src/landscape/C4Map.h
+	src/landscape/C4MapScript.cpp
+	src/landscape/C4MapScriptAlgo.cpp
+	src/landscape/C4MapScript.h
 	src/landscape/C4MassMover.cpp
 	src/landscape/C4MassMover.h
 	src/landscape/C4Material.cpp
@@ -351,7 +323,18 @@
 	src/landscape/C4PathFinder.h
 	src/landscape/C4PXS.cpp
 	src/landscape/C4PXS.h
-	src/landscape/C4Region.cpp
-	src/landscape/C4Region.h
 	src/landscape/C4Scenario.cpp
+	src/landscape/C4ScenarioSection.cpp
 	src/landscape/C4Scenario.h
+	src/landscape/C4Sky.cpp
+	src/landscape/C4Sky.h
+	src/landscape/C4SolidMask.cpp
+	src/landscape/C4SolidMask.h
+	src/landscape/C4Texture.cpp
+	src/landscape/C4Texture.h
+	src/landscape/C4Weather.cpp
+	src/landscape/C4Weather.h
+	src/lib/C4LogBuf.cpp
+	src/lib/C4LogBuf.h
+	src/lib/C4Log.cpp
+	src/lib/C4Log.h
