=== docs/Makefile ===
--- 
+++ 
@@ -1,8 +1,15 @@
-# Notable targets:
-# all (default): German and English onlinedocs
-# online-en: only English onlinedocs, which can be partially updated
-# Enwickler.chm: the German offline doc
-#                use with make Entwickler.chm HHC = /path/to/hhc
+# German and English online docs:
+#   make all
+#   make install prefix=/path/to/webspace
+# The offline docs:
+#   make chm HHC=/path/to/hhc.exe
+
+# Only English online docs, which can be partially updated:
+#   make online-en
+# The English offline doc:
+#   make chm/en/Developer.chm HHC=/path/to/hhc.exe
+# XML syntax check:
+#   make check
 
 # Extra Parameters for xsltproc can be given in the XSLTFLAGS variable.
 # Use prefix to select the directory where the docs are to be installed
@@ -53,10 +60,10 @@
 
 install: all
 	$(MKDIR_P) $(prefix)
-	$(CP_R) $(PWD)/online/* $(prefix)
+	$(CP_R) online/* $(prefix)
 
 check:
-	xmllint --noblanks --noout --valid $(xmlfiles)
+	@xmllint --noblanks --noout --valid $(xmlfiles)
 
 clean:
 	rm -f *.mo Entwickler.chm Developer.chm doku.pot sdk/content.xml
@@ -122,7 +129,7 @@
 	$(CP) $< $@
 
 chm/en/Developer.chm: chm/en/Output.hhp chm/en/Output.hhk chm/en/Output.hhc $(addprefix chm/en/, $(sdk-dirs) images $(htmlfiles) $(extra-files-chm))
-	"$(HHC)" $<
+	! "$(HHC)" $<
 chm/de/Entwickler.chm: chm/de/Output.hhp chm/de/Output.hhk chm/de/Output.hhc $(addprefix chm/de/, $(sdk-dirs) images $(htmlfiles) $(extra-files-chm))
-	"$(HHC)" $<
+	! "$(HHC)" $<
