=== thirdparty/tinyxml/CMakeLists.txt ===
add_library(tinyxml
	tinystr.cpp
	tinystr.h
	tinyxml.cpp
	tinyxml.h
	tinyxmlerror.cpp
	tinyxmlparser.cpp
)
