## openclonk 5.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # OpenClonk, http://www.openclonk.org
 #
-# Copyright (c) 2009-2013, The OpenClonk Team and contributors
+# Copyright (c) 2009-2014, The OpenClonk Team and contributors
 #
 # Distributed under the terms of the ISC license; see accompanying file
 # "COPYING" for details.
@@ -11,7 +11,7 @@
 # To redistribute this file separately, substitute the full license texts
 # for the above references.
 
-cmake_minimum_required (VERSION 2.6.0)
+cmake_minimum_required (VERSION 2.8.4)
 project (openclonk CXX C)
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -48,62 +48,49 @@
 CMAKE_DEPENDENT_OPTION(USE_GTK3 "Use GTK3 instead of GTK2" OFF "USE_GTK" OFF)
 
 CMAKE_DEPENDENT_OPTION(USE_COCOA "Use Apple Cocoa for the developer mode and the windows." ON "APPLE" OFF)
-CMAKE_DEPENDENT_OPTION(USE_APPLE_CLANG "Use Apple Clang Compiler as C++ compiler." ON "APPLE" OFF)
-if(APPLE)
-	SET(INITIAL_USE_OPEN_AL ON)
-else()
-	SET(INITIAL_USE_OPEN_AL OFF)
-endif()
-option(USE_OPEN_AL "Use OpenAL to play sounds" ${INITIAL_USE_OPEN_AL})
 option(WITH_AUTOMATIC_UPDATE "Automatic updates are downloaded from the project website." OFF)
+
+# We link Boost statically because that makes it easier for us to distribute
+# the resulting binary. Distributions have the ability to guarantee a certain
+# version of the library exists on the system though, so they may prefer
+# dynamic linking.
+option(USE_STATIC_BOOST "Link Boost libraries statically" ON)
 
 # Remove obsolete options
 unset(OC_BUILD_MULTIPROCESSOR CACHE)
+unset(USE_APPLE_CLANG CACHE)
 
 ############################################################################
 # Check for compiler quirks and features
 ############################################################################
 include(CheckCXXCompilerFlag)
-if(CMAKE_COMPILER_IS_GNUCXX)
-	CHECK_CXX_COMPILER_FLAG("-std=gnu++0x" USE_GCC_STD_0X)
-	if(USE_GCC_STD_0X)
-		list(APPEND OC_CXX_FLAGS "-std=gnu++0x")
-	endif()
-endif()
-
-# ck 09-09-20: CMAKE_REQUIRED_FLAGS requires a string, not a list.
 include(CheckCXXSourceCompiles)
+include(RequireCXXSourceCompiles)
+
+CHECK_CXX_COMPILER_FLAG("-std=gnu++0x" USE_GCC_STD_0X)
+if(USE_GCC_STD_0X)
+	list(APPEND OC_CXX_FLAGS "-std=gnu++0x")
+endif()
+
+# Convert the OC_CXX_FLAGS list to a CMAKE_CXX_FLAGS string
 foreach(FLAG ${OC_CXX_FLAGS})
 	set(OC_REQUIRED_FLAGS "${OC_REQUIRED_FLAGS} ${FLAG}")
 endforeach()
 
-# ck 10-09-04: Reset CMAKE_REQUIRED_FLAGS after having done the C++0x checks
-# otherwise they are used for C library checks as well and the C compiler bails
-# out because it does not understand -std=gnu++0x
-set(SAFE_CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
-set(CMAKE_REQUIRED_FLAGS ${OC_REQUIRED_FLAGS})
-include(RequireCXXSourceCompiles)
-if (NOT USE_APPLE_CLANG)
+set(CMAKE_CXX_FLAGS ${OC_REQUIRED_FLAGS})
+
 REQUIRE_CXX_SOURCE_COMPILES("#include <memory>\nint main() { std::unique_ptr<int> a; std::shared_ptr<int> b; }" HAVE_C11_SMART_PTRS)
-endif()
 CHECK_CXX_SOURCE_COMPILES("void f(struct D&&); int main() { return 0; }" HAVE_RVALUE_REF)
 CHECK_CXX_SOURCE_COMPILES("int main() { void *d = nullptr; }" HAVE_NULLPTR)
 CHECK_CXX_SOURCE_COMPILES("int main() { static_assert(true, \"\"); }" HAVE_STATIC_ASSERT)
-set(CMAKE_REQUIRED_FLAGS "${SAFE_CMAKE_REQUIRED_FLAGS}")
-
-# g++'s libstdc++ doesn't properly support <regex> until 4.8.1 (maybe later?).
+
+# g++'s libstdc++ doesn't properly support <regex> until 4.9.
 # They ship a header that declares functions, but they don't ship an
 # implementation for some things (like std::regex_iterator).
 # This needs to test *linking*, not compilation; cmake does both at the same
 # time, so the test below works.
 CHECK_CXX_SOURCE_COMPILES("#include <regex>\nint main() { std::cregex_iterator ri; }" HAVE_WORKING_REGEX)
 CMAKE_DEPENDENT_OPTION(USE_BOOST_REGEX "Use Boost.Regex even if the C++ runtime has a working implementation of <regex>" OFF "HAVE_WORKING_REGEX" ON)
-
-# We link Boost statically because that makes it easier for us to distribute
-# the resulting binary. Distributions have the ability to guarantee a certain
-# version of the library exists on the system though, so they may prefer
-# dynamic linking.
-option(USE_STATIC_BOOST "Link Boost libraries statically" ON)
 
 if(MSVC_VERSION GREATER 1499)
 		list(APPEND OC_CXX_FLAGS /MP)
@@ -338,3 +325,29 @@
 	src/lib/C4LogBuf.h
 	src/lib/C4Log.cpp
 	src/lib/C4Log.h
+	src/lib/C4NameList.cpp
+	src/lib/C4NameList.h
+	src/lib/C4Rect.cpp
+	src/lib/C4Rect.h
+	src/lib/C4RTF.cpp
+	src/lib/C4RTF.h
+	src/lib/C4Stat.cpp
+	src/lib/C4Stat.h
+	src/lib/PathFinder.cpp
+	src/lib/PathFinder.h
+	src/lib/StdAdaptors.h
+	src/lib/StdColors.h
+	src/lib/StdMesh.cpp
+	src/lib/StdMesh.h
+	src/lib/StdMeshLoaderBinaryChunks.cpp
+	src/lib/StdMeshLoaderBinaryChunks.h
+	src/lib/StdMeshLoaderBinary.cpp
+	src/lib/StdMeshLoaderDataStream.h
+	src/lib/StdMeshLoader.h
+	src/lib/StdMeshLoaderXml.cpp
+	src/lib/StdMeshMaterial.cpp
+	src/lib/StdMeshMaterial.h
+	src/lib/StdMeshMath.cpp
+	src/lib/StdMeshMath.h
+	src/lib/StdMeshUpdate.cpp
+	src/lib/StdMeshUpdate.h
