=== debian/changelog ===
openclonk (5.5.1-2) unstable; urgency=medium

  * Use the system tinyxml.

 -- Philipp Kern <pkern@debian.org>  Wed, 15 Oct 2014 00:06:11 +0200

openclonk (5.5.1-1) unstable; urgency=medium

  * Imported Upstream version 5.5.1
  * Bump minimum cmake version in build-depends.

 -- Philipp Kern <pkern@debian.org>  Mon, 13 Oct 2014 23:11:57 +0200
