=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 	dh $@ --buildsystem=cmake -Bbuild
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DWITH_AUTOMATIC_UPDATE=0 -DUSE_STATIC_BOOST=OFF
+	dh_auto_configure -- -DWITH_AUTOMATIC_UPDATE=0 -DUSE_STATIC_BOOST=OFF -DWITH_SYSTEM_TINYXML=ON
 
 override_dh_strip:
 	dh_strip --dbg-package=openclonk-dbg
